unit CsvList;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Menus,
  CommCtrl, IniFiles, mPlugin, System.UITypes;

const
  FORM_LEFT_SHIFT   = 9;
  FORM_TOP_SHIFT    = 9;
  FORM_WIDTH_SET    = 800;
  FORM_HEIGHT_SET   = 480;
  FORM_MAX          = 'MAX';
  FORM_MIN          = 'MIN';
  FORM_NORMAL       = 'NORMAL';
  INIT_SERACH       = 's:      :  ';

  CSVLIST_FONT_SIZE     = 12;
  CSVLIST_CAPTION_WIDTH = 60;
  CSVLIST_COL_MAX       = 96;
  SERACH_MAX            = 32;
  LINE_LENGTH_MAX       = 8192*2;
  HIGHI_LIGHT_MAX       = 65535;

  SHORTCUT_ITEM_FILE    = 't@C';
  SHORTCUT_ITEM_EDIT    = 'ҏW';
  SHORTCUT_ITEM_SEARCH  = '';
  SHORTCUT_ITEM_VIEW    = '\';
  SHORTCUT_ITEM_TOOL    = 'c[';
  SHORTCUT_ITEM_HELP    = 'wv';
  SHORTCUT_ITEM_CSV     = 'CSVݒ';

  KEYMAP_LIST        = 'MeryCsvList-KeyMap.txt';
  FIND_LIST          = 'MeryCsvList-Find.txt';
  HELP_LIST          = 'MeryCsvList.txt';
  INIFILE_NAME       = 'MeryCsvList.ini';
  DLL_FOLDER_NAME    = 'Plugins';

  VK_0 = Ord('0');
  VK_1 = Ord('1');
  VK_2 = Ord('2');
  VK_3 = Ord('3');
  VK_4 = Ord('4');
  VK_5 = Ord('5');
  VK_6 = Ord('6');
  VK_7 = Ord('7');
  VK_8 = Ord('8');
  VK_9 = Ord('9');
  VK_A = Ord('A');
  VK_B = Ord('B');
  VK_C = Ord('C');
  VK_D = Ord('D');
  VK_E = Ord('E');
  VK_F = Ord('F');
  VK_G = Ord('G');
  VK_H = Ord('H');
  VK_I = Ord('I');
  VK_J = Ord('J');
  VK_K = Ord('K');
  VK_L = Ord('L');
  VK_M = Ord('M');
  VK_N = Ord('N');
  VK_O = Ord('O');
  VK_P = Ord('P');
  VK_Q = Ord('Q');
  VK_R = Ord('R');
  VK_S = Ord('S');
  VK_T = Ord('T');
  VK_U = Ord('U');
  VK_V = Ord('V');
  VK_W = Ord('W');
  VK_X = Ord('X');
  VK_Y = Ord('Y');
  VK_Z = Ord('Z');

type
  TFormCsvList = class(TForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuCsvListLoadAll: TMenuItem;
    MenuCsvListFitColumnWidth: TMenuItem;
    MenuCsvListClose: TMenuItem;
    MenuSearch: TMenuItem;
    MenuCsvListSearchNext: TMenuItem;
    MenuCsvListSearchPrev: TMenuItem;
    MenuMove: TMenuItem;
    MenuCsvListTop: TMenuItem;
    MenuCsvListPrev: TMenuItem;
    MenuCsvListNext: TMenuItem;
    MenuCsvListEnd: TMenuItem;
    MenuView: TMenuItem;
    MenuCsvListFontColor: TMenuItem;
    MenuCsvListBackColor: TMenuItem;
    MenuSetting: TMenuItem;
    MenuCsvListKeyBoard: TMenuItem;
    MemuHelp: TMenuItem;
    MenuCsvListShowHelp: TMenuItem;
    MenuCsvListJump: TMenuItem;
    MenuMoveStartPosition: TMenuItem;
    MenuAddHeader: TMenuItem;
    MenuCsvAuto: TMenuItem;
    MenuCsvEx1: TMenuItem;
    MenuCsvListFontColorHilightRow: TMenuItem;
    MenuCsvListHiLightRow: TMenuItem;
    MenuCsvListHiligtFile: TMenuItem;
    MenuCsvSetting: TMenuItem;
    MenuCsvListHiLightCol: TMenuItem;
    MenuCsvListHiLightNone: TMenuItem;
    MenuCsvListFontColorHilightCol: TMenuItem;
    ButtonPrev: TButton;
    ButtonNext: TButton;
    ButtonCancel: TButton;
    ButtonFitColumnWidth: TButton;
    ButtonSearchPrev: TButton;
    ButtonSearchNext: TButton;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ListView1: TListView;
    StatusBar1: TStatusBar;
    Separater31: TMenuItem;
    Separater41: TMenuItem;
    Separater42: TMenuItem;
    Timer1: TTimer;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox3KeyPress(Sender: TObject; var Key: Char);
    procedure MenuCsvListTopClick(Sender: TObject);
    procedure MenuCsvListPrevClick(Sender: TObject);
    procedure MenuCsvListNextClick(Sender: TObject);
    procedure MenuCsvListEndClick(Sender: TObject);
    procedure MenuCsvListCloseClick(Sender: TObject);
    procedure MenuCsvListLoadAllClick(Sender: TObject);
    procedure MenuCsvListSearchNextClick(Sender: TObject);
    procedure MenuCsvListSearchPrevClick(Sender: TObject);
    procedure MenuCsvListFitColumnWidthClick(Sender: TObject);
    procedure MenuCsvListFontColorClick(Sender: TObject);
    procedure MenuCsvListBackColorClick(Sender: TObject);
    procedure MenuCsvListShowHelpClick(Sender: TObject);
    procedure MenuCsvListKeyBoardClick(Sender: TObject);
    procedure MenuCsvListJumpClick(Sender: TObject);
    procedure MenuMoveStartPositionClick(Sender: TObject);
    procedure MenuAddHeaderClick(Sender: TObject);
    procedure MenuCsvListHiligtFileClick(Sender: TObject);
    procedure MenuCsvListHiLightRowClick(Sender: TObject);
    procedure MenuCsvAutoClick(Sender: TObject);
    procedure MenuCsvEx1Click(Sender: TObject);
    procedure MenuCsvListFontColorHilightRowClick(Sender: TObject);
    procedure MenuCsvListHiLightNoneClick(Sender: TObject);
    procedure MenuCsvListHiLightColClick(Sender: TObject);
    procedure MenuCsvListFontColorHilightColClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1AdvancedCustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      Stage: TCustomDrawStage; var DefaultDraw: Boolean);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);

    procedure ButtonPrevClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonFitColumnWidthClick(Sender: TObject);
    procedure ButtonSearchPrevClick(Sender: TObject);
    procedure ButtonSearchNextClick(Sender: TObject);

    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure SetShortCutKey(Sender: TObject);
    procedure SetListData(Sender: TObject);
    procedure StringToCsvList(SrcString: String; CsvList: TstringList);
    procedure StringToCsvListEx1(SrcString: String; CsvList: TstringList);
    procedure InitKeyMap(Sender: TObject);
    function  GetLine(Index: Integer; var LineString: String; Sender: TObject): Integer;

  private
    { Private 錾 }
    StrFormState: String;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    BoolStrLengthOver: Boolean;
    BoolLoadAll: Boolean;
    StrSearchValue: String;
    StrHighLightFileName: String;
    IntSearchRow: Integer;
    IntSearchCol: Integer;
    IntMoveNum: Integer;
    IntStartNum: Integer;
    IntLineStart: Integer;
    IntLineEnd: Integer;
    IntLineAllStart: Integer;
    IntEditorAllCount: Integer;
    IntEditorRow: Integer;
    StrListKeyMap: TStringList;
    StrListEditorLines: TSTringList;
    StrListEditorAllLines: TSTringList;
    StrListHighLight: TSTringList;
    ArrayListHighLightRow: array [0..HIGHI_LIGHT_MAX] of Integer;
    ArrayListHighLightCol: array [0..HIGHI_LIGHT_MAX] of Integer;

  public
    { Public 錾 }
    StrIniFileName: String;
    StrDllFilePath: String;
    StrListKeyMapOriginal: TStringList;

  end;

var
  FormCsvList: TFormCsvList;

implementation


{$R *.dfm}

uses
  KeyBoard, Help, Jump;

procedure TFormCsvList.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormCsvList.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
  iRow1: Integer;
  iMax1: Integer;
  StrList1: TStringList;
begin
  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormCsvList', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormCsvList', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormCsvList', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormCsvList', 'Left',   FormCsvList.Left);
    IniFile.WriteInteger('FormCsvList', 'Top',    FormCsvList.Top);
    IniFile.WriteInteger('FormCsvList', 'Width',  FormCsvList.Width);
    IniFile.WriteInteger('FormCsvList', 'Height', FormCsvList.Height);
  end;
  //ۑ
  IniFile.WriteInteger('CsvList', 'DispNum' , ComboBox1.ItemIndex);
  IniFile.WriteInteger('CsvList', 'ColWidth', ComboBox2.ItemIndex);
  //ۑ
  IniFile.WriteBool  ('CsvListHighLight', 'None',     MenuCsvListHiLightNone.Checked);
  IniFile.WriteBool  ('CsvListHighLight', 'Row',      MenuCsvListHiLightRow.Checked);
  IniFile.WriteBool  ('CsvListHighLight', 'Col',      MenuCsvListHiLightCol.Checked);
  IniFile.WriteString('CsvListHighLight', 'FileName', StrHighLightFileName);
  //ۑ
  IniFile.WriteBool  ('CsvListAuto', 'Enabled',  MenuCsvAuto.Checked);
  IniFile.WriteBool  ('CsvListEx1',  'Enabled',  MenuCsvEx1.Checked);
  //ۑ
  IniFile.WriteString('CsvListColor',          'FontName',  FontDialog1.Font.Name);
  IniFile.WriteString('CsvListColor',          'FontSize',  IntToStr(FontDialog1.Font.Size));
  IniFile.WriteString('CsvListColor',          'FontColor', ColorToString(FontDialog1.Font.Color));
  IniFile.WriteString('CsvListColor',          'BackColor', ColorToString(ColorDialog1.Color));
  IniFile.WriteString('CsvListColorHighLight', 'FontColor', ColorToString(ColorDialog2.Color));
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
  StrListKeyMapOriginal.Free;
  StrListEditorLines.Free;
  StrListEditorAllLines.Free;
  StrListHighLight.Free;

  //m
  StrList1 := TStringList.Create;
  //ő͈
  iMax1 := ComboBox3.Items.Count;
  if iMax1 > SERACH_MAX then
  begin
    iMax1 := SERACH_MAX;
  end;
  //ۑ
  StrList1.Clear;
  for iRow1 := 0 to iMax1-1 do
  begin
    StrList1.Add(ComboBox3.Items.Strings[iRow1]);
  end;
  StrList1.SaveToFile(StrDllFilePath + FIND_LIST);
  //j
  StrList1.Free;
end;

procedure TFormCsvList.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormCsvList.FormCreate(Sender: TObject);
begin
  //
end;

procedure TFormCsvList.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TFormCsvList.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  else if  (key = VK_UP) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_UP) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_UP) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_DOWN) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_PRIOR) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_NEXT) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_HOME) then
  begin
    IntSearchCol := 0;
  end
  else if  (key = VK_END) then
  begin
    IntSearchCol := 0;
  end
  //
  else
  begin
    ;
  end;
end;

procedure TFormCsvList.FormResize(Sender: TObject);
begin
  //
end;

procedure TFormCsvList.FormShow(Sender: TObject);
var
  StrList1: TStringList;
  IniFile: TiniFile;
  iIndex1: Integer;
  iIndex2: Integer;
  iCol1: Integer;
  sStr1: String;
begin

  //Memo1.Visible := FALSE;

  //
  Timer1.Enabled := FALSE;

  //ݒ
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.ReadOnly := TRUE;

  //m
  StrListKeyMap := TStringList.Create;
  StrListKeyMapOriginal := TStringList.Create;
  StrListEditorLines := TSTringList.Create;
  StrListEditorAllLines := TSTringList.Create;
  StrListHighLight := TSTringList.Create;

  //
  IntFormShiftX   := 0;
  IntFormShiftY   := 0;

  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;
  StrDllFilePath := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\';

  //m
  StrList1 := TStringList.Create;
  //Ǎ
  if FileExists(StrDllFilePath + FIND_LIST) = TRUE then
  begin
    StrList1.LoadFromFile(StrDllFilePath + FIND_LIST);
  end
  else
  begin
    StrList1.Clear;
  end;
  ComboBox3.Items.Assign(StrList1);
  ComboBox3.Text := '';
  //j
  StrList1.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);

  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormCsvList', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormCsvList', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormCsvList', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormCsvList', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormCsvList', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //Ǎ
  FontDialog1.Font.Name  :=               IniFile.ReadString('CsvListColor', 'FontName',       'lr SVbN');
  FontDialog1.Font.Size  := StrToInt     (IniFile.ReadString('CsvListColor', 'FontSize',       '14'));
  FontDialog1.Font.Color := StringToColor(IniFile.ReadString('CsvListColor', 'FontColor',      ColorToString(clBlack)));
  ColorDialog1.Color     := StringToColor(IniFile.ReadString('CsvListColor', 'BackColor',      ColorToString(clWhite)));
  ColorDialog2.Color     := StringToColor(IniFile.ReadString('CsvListColorHighLight', 'Color', ColorToString(clRed)));
  ListView1.Font.Name  := FontDialog1.Font.Name;
  ListView1.Font.Size  := FontDialog1.Font.Size;
  ListView1.Font.Color := FontDialog1.Font.Color;
  ListView1.Color      := ColorDialog1.Color;
  //Ǎ
  iIndex1 := IniFile.ReadInteger('CsvList', 'DispNum',  5);
  if iIndex1 < 0 then
  begin
    iIndex1 := 0;
  end;
  ComboBox1.ItemIndex := iIndex1;
  //Ǎ
  iIndex2  := IniFile.ReadInteger('CsvList', 'ColWidth', 2);
  if iIndex2 < 0 then
  begin
    iIndex2 := 0;
  end;
  ComboBox2.ItemIndex := iIndex2;
  //ړs
  IntMoveNum := StrToInt(ComboBox1.Text);
  //Ǎ
  MenuCsvListHiLightNone.Checked := IniFile.ReadBool  ('CsvListHighLight', 'None', TRUE);
  MenuCsvListHiLightRow.Checked  := IniFile.ReadBool  ('CsvListHighLight', 'Row',  FALSE);
  MenuCsvListHiLightCol.Checked  := IniFile.ReadBool  ('CsvListHighLight', 'Col',  FALSE);
  StrHighLightFileName           := IniFile.ReadString('CsvListHighLight', 'FileName', '');
  if FileExists(StrHighLightFileName) = TRUE then
  begin
    StrListHighLight.LoadFromFile(StrHighLightFileName);
  end;
  //Ǎ
  MenuCsvAuto.Checked := IniFile.ReadBool  ('CsvListAuto', 'Enabled', TRUE);
  MenuCsvEx1.Checked  := IniFile.ReadBool  ('CsvListEx1',  'Enabled', TRUE);
  //bŏ펞L
  MenuCsvEx1.Enabled := FALSE;
  //j
  IniFile.Free;

  //
  StatusBar1.Panels.Items[3].Text := INIT_SERACH;

  //ݒ
  StatusBar1.Panels.Items[0].Width := 70;
  StatusBar1.Panels.Items[1].Width := 70;
  StatusBar1.Panels.Items[2].Width := 70;
  StatusBar1.Panels.Items[3].Width := 70;

  //ݒ
  BoolLoadAll := FALSE;

  //܂ԂlȂl
  IntEditorAllCount := Editor_GetLines(Application.Handle, 1); // s
  IntEditorRow := Editor_LineFromChar(Application.Handle, 1, Int64(-1)); // 0 x[X
  IntStartNum := IntEditorRow;

  //\
  //Memo1.Lines.BeginUpdate;
  //Memo1.Lines.Assign(StrListEditorLines);
  //Memo1.Lines.EndUpdate;

  //=======================================
  //́AFormCreate 玝Ă
  //=======================================


  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormCsvList.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormCsvList.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormCsvList.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ڂ͎Oɍ쐬Ă
  //ݒ
  ListView1.Items.BeginUpdate;
  ListView1.Columns[0].Caption  := 'No';
  ListView1.Columns[0].Width := CSVLIST_CAPTION_WIDTH * FontDialog1.Font.Size div CSVLIST_FONT_SIZE;
  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ݒ
  for iCol1 := 0 to CSVLIST_COL_MAX-1 do
  begin
    ListView1.Columns[iCol1+1].Caption := Format('%.02d', [iCol1+1]);
    ListView1.Columns[iCol1+1].Width   := StrToInt(ComboBox2.Text);
  end;
  //j
  IniFile.Free;
  ListView1.Items.EndUpdate;

  //ݒ
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  ListView1.Items.EndUpdate;

  //ݒ
  IntLineStart := IntEditorRow;
  //ݒ
  IntLineEnd := IntLineStart + IntMoveNum;
  if IntLineEnd > IntEditorAllCount then
  begin
    IntLineEnd := IntEditorAllCount;
  end;
  //f[^\
  SetListData(Sender);


  //ݒ
  InitKeyMap(Sender);

  //t@CǍ
  sStr1 := StrDllFilePath + KEYMAP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1);
    //r
    if StrListKeyMap.Count <> StrListKeyMapOriginal.Count then
    begin
      //ۑ
      StrListKeyMap.Assign(StrListKeyMapOriginal);
      StrListKeyMap.SaveToFile(sStr1);
      //N
      Timer1.Enabled := TRUE;
    end;
  end
  else
  begin
    //ۑ
    StrListKeyMap.Assign(StrListKeyMapOriginal);
    StrListKeyMap.SaveToFile(sStr1);
  end;

  //V[gJbgݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1001', MenuCsvListLoadAll, Sender);
    SetShortCutNew('1002', MenuCsvListFitColumnWidth, Sender);
    SetShortCutNew('1011', MenuCsvListClose, Sender);
    SetShortCutNew('1101', MenuCsvListSearchNext, Sender);
    SetShortCutNew('1102', MenuCsvListSearchPrev, Sender);
    SetShortCutNew('1201', MenuCsvListJump, Sender);
    SetShortCutNew('1202', MenuCsvListTop, Sender);
    SetShortCutNew('1203', MenuCsvListPrev, Sender);
    SetShortCutNew('1204', MenuCsvListNext, Sender);
    SetShortCutNew('1205', MenuCsvListEnd, Sender);
    SetShortCutNew('1301', MenuCsvListFontColor, Sender);
    SetShortCutNew('1302', MenuCsvListBackColor, Sender);
    SetShortCutNew('1303', MenuCsvListHiligtFile, Sender);
    SetShortCutNew('1304', MenuCsvListFontColorHilightRow, Sender);
    SetShortCutNew('1305', MenuCsvListFontColorHilightCol, Sender);
    SetShortCutNew('1306', MenuCsvListHiLightNone, Sender);
    SetShortCutNew('1307', MenuCsvListHiLightRow, Sender);
    SetShortCutNew('1308', MenuCsvListHiLightCol, Sender);
    SetShortCutNew('1401', MenuCsvListKeyBoard, Sender);
    SetShortCutNew('1501', MenuCsvListShowHelp, Sender);
    SetShortCutNew('1601', MenuCsvAuto, Sender);
    SetShortCutNew('1602', MenuCsvEx1, Sender);
  end;

  //tH[JX
  ListView1.SetFocus;
end;

procedure TFormCsvList.InitKeyMap(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //NA
  StrListKeyMapOriginal.Clear;

  //File
  sStr1 :=                FormCsvList.MenuCsvListLoadAll.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListLoadAll.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1001');

  sStr1 :=                FormCsvList.MenuCsvListFitColumnWidth.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListFitColumnWidth.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1002');

  sStr1 :=                FormCsvList.MenuAddHeader.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuAddHeader.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1003');

  sStr1 :=                FormCsvList.MenuCsvListClose.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListClose.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1011');

  //Search
  sStr1 :=                FormCsvList.MenuCsvListSearchNext.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListSearchNext.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1101');

  sStr1 :=                FormCsvList.MenuCsvListSearchPrev.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListSearchPrev.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1102');

  //Edit
  sStr1 :=                FormCsvList.MenuCsvListJump.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListJump.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1201');

  sStr1 :=                FormCsvList.MenuMoveStartPosition.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuMoveStartPosition.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1202');

  sStr1 :=                FormCsvList.MenuCsvListTop.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListTop.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1203');

  sStr1 :=                FormCsvList.MenuCsvListPrev.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListPrev.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1204');

  sStr1 :=                FormCsvList.MenuCsvListNext.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListNext.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1205');

  sStr1 :=                FormCsvList.MenuCsvListEnd.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListEnd.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1206');

  //View
  sStr1 :=                FormCsvList.MenuCsvListFontColor.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListFontColor.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1301');

  sStr1 :=                FormCsvList.MenuCsvListBackColor.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListBackColor.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1302');

  sStr1 :=                FormCsvList.MenuCsvListHiligtFile.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListHiligtFile.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1303');

  sStr1 :=                FormCsvList.MenuCsvListFontColorHilightRow.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListFontColorHilightRow.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1304');

  sStr1 :=                FormCsvList.MenuCsvListFontColorHilightCol.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListFontColorHilightCol.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1305');

  sStr1 :=                FormCsvList.MenuCsvListHiLightNone.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListHiLightNone.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1306');

  sStr1 :=                FormCsvList.MenuCsvListHiLightRow.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListHiLightRow.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1307');

  sStr1 :=                FormCsvList.MenuCsvListHiLightCol.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListHiLightCol.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1308');

  //Tool
  sStr1 :=                FormCsvList.MenuCsvListKeyBoard.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListKeyBoard.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_TOOL + #09 + sStr1 + #09 + sStr2 + #09 + '1401');

  //Help
  sStr1 :=                FormCsvList.MenuCsvListShowHelp.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvListShowHelp.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_HELP + #09 + sStr1 + #09 + sStr2 + #09 + '1501');

  //Csv
  sStr1 :=                FormCsvList.MenuCsvAuto.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvAuto.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_CSV + #09 + sStr1 + #09 + sStr2 + #09 + '1601');

  sStr1 :=                FormCsvList.MenuCsvEx1.Caption;
  sStr2 := ShortCutToText(FormCsvList.MenuCsvEx1.ShortCut);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_CSV + #09 + sStr1 + #09 + sStr2 + #09 + '1602');

end;

procedure TFormCsvList.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    Exit;
  end;
  //ݒ
  sStr3 := sStr16;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;


procedure TFormCsvList.ComboBox1Change(Sender: TObject);
begin
  //S
  if BoolLoadAll = TRUE then
  begin
    //All ł͖ɂĂ̂ŁA͂Ȃ
    //showmessage('SĂ\Ă̂ŁA̕\̎ɔf܂');
    //Exit;
  end
  //s
  else
  begin
    //ړs
    IntMoveNum := StrToInt(ComboBox1.Text);
    //ݒ
    IntLineEnd := IntLineStart + IntMoveNum;
    if IntLineEnd > IntEditorAllCount-1 then
    begin
      IntLineEnd := IntEditorAllCount-1;
    end;
    //\XV
    SetListData(Sender);
  end;
end;

procedure TFormCsvList.ComboBox2Change(Sender: TObject);
var
  iCol1: Integer;
begin
  //XV
  ListView1.Items.BeginUpdate;
  //ύX
  for iCol1 := 0 to CSVLIST_COL_MAX-1 do
  begin
    ListView1.Columns[iCol1+1].Width := StrToInt(ComboBox2.Text);
  end;
  //XV
  ListView1.Items.EndUpdate;
end;

procedure TFormCsvList.StringToCsvListEx1(SrcString: String; CsvList: TstringList);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  iPos1: Integer;
  iPos2: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iVal1: Integer;
  iVal2: Integer;
  iVal3: Integer;
  bFind1: Boolean;
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
begin
  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;

// 11,"22,22",33
// 1,2,3
// "11,22"
// 11,"22,""22",33

  //f[^̐ݒ
  //擪ɒǉ
  sStr1 := ',' + SrcString;

  //ŏɒu
  sStr2 := StringReplace(sStr1, '""', #$0C, [rfReplaceAll]);

  //
  bFind1 := FALSE;
  for iRow1 := 0 to Length(sStr2)-1 do
  begin
    if Copy(sStr2, iRow1+1, 1) = '"' then
    begin
      if bFind1 = FALSE then
      begin
        StrList1.Add(IntToStr(iRow1));
        bFind1 := TRUE;
      end
      else
      begin
        StrList2.Add(IntToStr(iRow1));
        bFind1 := FALSE;
      end;
    end
    else if Copy(sStr2, iRow1+1, 1) = ',' then
    begin
        StrList3.Add(IntToStr(iRow1));
    end
    else
    begin
      //
    end;
  end;

  //2dp̊ԂɂJ}폜
  for iRow1 := 0 to StrList3.Count-1 do
  begin
    //ڐ
    if StrList1.Count = StrList2.Count then
    begin
      if StrList1.Count = 0 then
      begin
            StrList4.Add(StrList3.Strings[iRow1]);
      end
      else
      begin
        //ԍ
        iVal1 := StrToInt(StrList3.Strings[iRow1]);
        for iRow2 := 0 to StrList1.Count-1 do
        begin
          //ԍ
          iVal2 := StrToInt(StrList1.Strings[iRow2]);
          //ԍ
          iVal3 := StrToInt(StrList2.Strings[iRow2]);
          //͈͓
          if (iVal1 > iVal2) and (iVal1 < iVal3)  then
          begin
            //
          end
          else
          begin
            StrList4.Add(StrList3.Strings[iRow1]);
          end;
        end;
      end;
    end;
  end;
          StrList4.Add(IntToStr(Length(sStr2)));

  //ɖ߂
  sStr3 := StringReplace(sStr2, #$0C, '"', [rfReplaceAll]);

  if StrList4.Count = 1 then
  begin
      //擾
      iPos1 := 0;
      iPos2 := StrToInt(StrList4.Strings[0]);
      sStr4 := Copy(sStr3, iPos1+2, iPos2 - iPos1 - 1);
      if Length(sStr4) > 0 then
      begin
        //ǉ
        CsvList.Add(sStr4);
      end;
  end
  else
  begin
    //ݒ
    for iRow1 := 0 to StrList4.Count-2 do
    begin
      //擾
      iPos1 := StrToInt(StrList4.Strings[iRow1+0]);
      iPos2 := StrToInt(StrList4.Strings[iRow1+1]);
      sStr4 := Copy(sStr3, iPos1+2, iPos2 - iPos1 - 1);
      if Length(sStr4) > 2 then
      begin
        if (Copy(sStr4, 1, 1) = '"') and (Copy(sStr4, Length(sStr4), 1) = '"') then
        begin
          sStr5 := Copy(sStr4, 2, Length(sStr4)-2);
        end
        else
        begin
          sStr5 := sStr4;
        end;
      end
      else
      begin
          sStr5 := sStr4;
      end;
      //ǉ
      CsvList.Add(sStr5);
    end;
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;
  StrList4.Free;

end;

procedure TFormCsvList.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;
  //
  showmessage('L[{[hݒ荀ڂύXɂȂ̂ŁAL[{[hݒ܂');
end;

procedure TFormCsvList.StringToCsvList(SrcString: String; CsvList: TstringList);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  sStr1: String;
  sSearch: String;
  sAfter: String;
begin
  Application.ProcessMessages;
  //f[^̐ݒ
  sStr1 := SrcString;
  //^ũf[^
  iPos1 := Pos(string(char($09)), sStr1);
  if iPos1 > 0 then
  begin
    while iPos1 > 0 do
    begin
      //TAB ȑO
      sSearch := Copy(sStr1, 1, iPos1-1);
      //TAB ȍ~
      sAfter := Copy(sStr1, iPos1+1, Length(sStr1));
      //Xgɒǉ
      CsvList.Add(sSearch);
      //Đݒ肵čČ
      sStr1 := sAfter;
      iPos1 := Pos(string(char($09)), sStr1);
    end;
    //Ō̕Xgɒǉ
    CsvList.Add(sStr1);
  end

  //J}dp̃f[^
  else
  begin
    //Đ擪ɂ dp̃f[^
    iPos1 := Pos('"', sStr1);
    if iPos1 = 1 then
    begin
      //" ؂
      //" ȍ~
      sAfter := Copy(sStr1, 2, Length(sStr1));
      //ēxčŌɂ
      iPos2 := Pos('"', sAfter);
      if iPos2 = Length(sAfter) then
      begin
        //dpP̃f[^
        //" ȍ~ " ȑO
        sSearch := Copy(sStr1, 2, Length(sStr1)-2);
        //Xgɒǉ
        CsvList.Add(sSearch);
      end

      //ēxčŌɂȂ
      else
      begin
        //dp̃f[^
        //" ȍ~
        sAfter := Copy(sStr1, 2, Length(sStr1));
        //Đݒ肵čČ
        sStr1 := sAfter;
        iPos2 := Pos('","', sStr1);
        while (iPos2 > 0) do
        begin
          //" ȍ~ " ȑO
          sSearch := Copy(sStr1, 1, iPos2-1);
          //", ȍ~
          sAfter := Copy(sStr1, iPos2+3, Length(sStr1));
          //Xgɒǉ
          CsvList.Add(sSearch);
          //Đݒ肵čČ
          sStr1 := sAfter;
          iPos2 := Pos('","', sStr1);
        end;
        //Ō̕Xgɒǉ
        //" ȑO
        sSearch := Copy(sStr1, 1, Length(sStr1)-1);
        CsvList.Add(sSearch);
      end;
    end

    //ĂȂ J}؂̃f[^
    else
    begin
      //" ؂
      //ĂȂ
      iPos3 := Pos(',', sStr1);
      if iPos3 = 0 then
      begin
        //P̃f[^
        //̂܂
        sSearch := Copy(sStr1, 1, Length(sStr1));
        //Xgɒǉ
        CsvList.Add(sSearch);
      end
      //Ă
      else
      begin
        //Ō܂Ō
        while (iPos3 > 0) do
        begin
          //, ȑO
          sSearch := Copy(sStr1, 1, iPos3-1);
          //, ȍ~
          sAfter := Copy(sStr1, iPos3+1, Length(sStr1));
          //Xgɒǉ
          CsvList.Add(sSearch);
          //Đݒ肵čČ
          sStr1 := sAfter;
          iPos3 := Pos(',', sStr1);
        end;
        //Ō̕Xgɒǉ
        CsvList.Add(sStr1);
      end;
    end;
  end;
end;

procedure TFormCsvList.ButtonPrevClick(Sender: TObject);
begin
  //O
  MenuCsvListPrevClick(Sender);
end;

procedure TFormCsvList.ButtonNextClick(Sender: TObject);
begin
  //
  MenuCsvListNextClick(Sender);
end;

procedure TFormCsvList.ButtonFitColumnWidthClick(Sender: TObject);
begin
  //
  MenuCsvListFitColumnWidthClick(Sender);
end;

procedure TFormCsvList.ButtonCancelClick(Sender: TObject);
begin
  //I
  MenuCsvListCloseClick(Sender);
end;

procedure TFormCsvList.MenuCsvListLoadAllClick(Sender: TObject);
var
  iRow1: Integer;
  sStr1: String;
  sStr3: String;
  wRet3: Word;
begin
  //
  if IntEditorAllCount > 500 then
  begin
    //mF
    sStr3 := '500sȏł͎Ԃ܂(500sŖ5b)' + #13#10 +
             '̃t@C ' + Format('%d', [IntEditorAllCount]) + ' słAs܂H';
    wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
    //s
    if wRet3 = mrYes then
    begin
      //
    end
    //~
    else
    begin
      Exit;
    end;
  end;

  //ݒ
  BoolLoadAll := TRUE;
  ComboBox1.Enabled := FALSE;

  //]
  StrListEditorAllLines.Clear;
  BoolStrLengthOver := FALSE;
  for iRow1 := 0 to IntEditorAllCount-1 do
  begin
    //Ps擾
    if GetLine(iRow1, sStr1, Sender) > LINE_LENGTH_MAX then
    begin
      BoolStrLengthOver := TRUE;
    end;
    StrListEditorAllLines.Add(sStr1);
  end;

  //ݒ
  IntLineAllStart := 0;
  //f[^\
  SetListData(Sender);
  //tH[JXݒ
  ListView1.SetFocus;

  //TCYI[o
  if BoolStrLengthOver = TRUE then
  begin
    showmessage('Ps̍s '  + Format('%d', [LINE_LENGTH_MAX]) + ' 𒴂s܂');
    Exit;
  end;

end;

procedure TFormCsvList.MenuCsvListFitColumnWidthClick(Sender: TObject);
var
  iCol1: Integer;
  sStr3: String;
  wRet3: Word;
begin
  //
  if BoolLoadAll = TRUE then
  begin
    //
    if IntEditorAllCount > 500 then
    begin
      //mF
      sStr3 := '500sȏł͎Ԃ܂(500sŖ10b)' + #13#10 +
               '̃t@C ' + Format('%d', [IntEditorAllCount]) + ' słAs܂H';
      wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
      //s
      if wRet3 = mrYes then
      begin
        //
      end
      //~
      else
      begin
        Exit;
      end;
    end;
  end;

  //XV
  ListView1.Items.BeginUpdate;
  //J̎ wb_[܂߂
  for iCol1 := 0 to CSVLIST_COL_MAX-1 do
  begin
    Application.ProcessMessages;
    if (iCol1 mod 10) = 0 then
    begin
      StatusBar1.Panels.Items[0].Text := Format('%.02d', [iCol1+1]);
      StatusBar1.Update;
    end;

    ListView_SetColumnWidth(ListView1.Handle, iCol1+1, LVSCW_AUTOSIZE_USEHEADER);
//    ListView_SetColumnWidth(ListView1.Handle, iCol1+1, LVSCW_AUTOSIZE);
  end;
      StatusBar1.Panels.Items[0].Text := Format('%.02d', [CSVLIST_COL_MAX]);
      StatusBar1.Update;
  //XV
  ListView1.Items.EndUpdate;
  //tH[JXݒ
  ListView1.SetFocus;
end;

procedure TFormCsvList.MenuCsvListCloseClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormCsvList.MenuCsvListKeyBoardClick(Sender: TObject);
var
  sStr1: String;
begin
  //
  FormKeyBoard := TFormKeyBoard.Create(Application);
  try
    //\
    FormKeyBoard.ShowModal;
  finally
    //j
    FormKeyBoard.Free;
  end;

  //t@CǍ
  sStr1 := StrDllFilePath + KEYMAP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1);
  end
  else
  begin
    //ۑ
    StrListKeyMap.Assign(StrListKeyMapOriginal);
  end;

  //V[gJbgݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1001', MenuCsvListLoadAll, Sender);
    SetShortCutNew('1002', MenuCsvListFitColumnWidth, Sender);
    SetShortCutNew('1003', MenuAddHeader, Sender);
    SetShortCutNew('1011', MenuCsvListClose, Sender);
    SetShortCutNew('1101', MenuCsvListSearchNext, Sender);
    SetShortCutNew('1102', MenuCsvListSearchPrev, Sender);
    SetShortCutNew('1201', MenuCsvListJump, Sender);
    SetShortCutNew('1202', MenuMoveStartPosition, Sender);
    SetShortCutNew('1203', MenuCsvListTop, Sender);
    SetShortCutNew('1204', MenuCsvListPrev, Sender);
    SetShortCutNew('1205', MenuCsvListNext, Sender);
    SetShortCutNew('1206', MenuCsvListEnd, Sender);
    SetShortCutNew('1301', MenuCsvListFontColor, Sender);
    SetShortCutNew('1302', MenuCsvListBackColor, Sender);
    SetShortCutNew('1401', MenuCsvListKeyBoard, Sender);
    SetShortCutNew('1501', MenuCsvListShowHelp, Sender);
  end;
end;

procedure TFormCsvList.MenuCsvListShowHelpClick(Sender: TObject);
begin
  //
  FormHelp := TFormHelp.Create(Application);
  try
    //\
    FormHelp.ShowModal;
  finally
    //j
    FormHelp.Free;
  end;
end;

procedure TFormCsvList.MenuCsvListTopClick(Sender: TObject);
begin
  //S
  if BoolLoadAll = TRUE then
  begin
    //bZ[WM
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_CONTROL, 0);
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_HOME, 0);
  end
  //s
  else
  begin
    //
    if IntLineStart = 0 then
    begin
      Exit;
    end;

    //ݒ
    IntLineStart := 0;
    //ݒ
    IntLineEnd := IntLineStart + IntMoveNum;
    if IntLineEnd > IntEditorAllCount-1 then
    begin
      IntLineEnd := IntEditorAllCount-1;
    end;
    //\XV
    SetListData(Sender);
  end;
end;

procedure TFormCsvList.MenuCsvListJumpClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  iPos1: Integer;
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
  bResult: Boolean;
begin
  //
  FormJump := TFormJump.Create(Application);
  try
    //\
    if FormJump.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormJump.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create(StrIniFileName);
    //ǂݍ
    sStr1 := IniFile.ReadString('Editor', 'Jump',  '1');
    iPos1 := StrToInt(sStr1);
    //j
    IniFile.Free;

    //͈͂
    iPos1 := iPos1 -1;
    if iPos1 < 0 then
    begin
      iPos1 := 0;
    end;
    if iPos1 > IntEditorAllCount-1 then
    begin
      iPos1 := IntEditorAllCount-1;
    end;

    //S
    if BoolLoadAll = TRUE then
    begin
      //ڂɃtH[JX킳Ȃƃ_BDelph7 ͕KvBXE2͂ȂĂvB
      //擪ȊO̓J[\ړőΉ
      ListView1.Items.BeginUpdate;
      ListView1.ItemIndex := iPos1;
      ListView1.Selected := ListView1.Items[iPos1];
      ListView1.ItemFocused := ListView1.Items[iPos1];
      //1s̍擾ăXN[
      iIndex1 := ListView1.TopItem.Index;
      iIndex2 := ListView1.ItemIndex;
      Rect1 := ListView1.Items[0].DisplayRect(drBounds);
      ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
      ListView1.Items.EndUpdate;
    end
    //s
    else
    begin
      //ݒ
      IntLineStart := iPos1;
      if IntLineStart < 0 then
      begin
        IntLineStart := 0;
      end;
      //ݒ
      IntLineEnd := IntLineStart + IntMoveNum;
      if IntLineEnd > IntEditorAllCount-1 then
      begin
        IntLineEnd := IntEditorAllCount-1;
      end;
      //\XV
      SetListData(Sender);
    end;
    //tH[JXݒ
    ListView1.SetFocus;
  end;
end;

procedure TFormCsvList.MenuCsvListPrevClick(Sender: TObject);
begin
  //S
  if BoolLoadAll = TRUE then
  begin
    //bZ[WM
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_PRIOR, 0);
  end
  //s
  else
  begin
    //
    if IntLineStart = 0 then
    begin
      Exit;
    end;

    //ݒ
    IntLineStart := IntLineStart - IntMoveNum;
    if IntLineStart < 0 then
    begin
      IntLineStart := 0;
    end;
    //ݒ
    IntLineEnd := IntLineStart + IntMoveNum;
    if IntLineEnd > IntEditorAllCount-1 then
    begin
      IntLineEnd := IntEditorAllCount-1;
    end;
    //\XV
    SetListData(Sender);
  end;
end;

procedure TFormCsvList.MenuCsvListNextClick(Sender: TObject);
begin
  //S
  if BoolLoadAll = TRUE then
  begin
    //bZ[WM
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_NEXT, 0);
  end
  //s
  else
  begin
    //
    //͕̍sŔ肷
    if IntLineStart = IntEditorAllCount-1 then
    begin
      Exit;
    end;

    //ݒ
    IntLineStart := IntLineStart + IntMoveNum;
    if IntLineStart > IntEditorAllCount-1 then
    begin
      IntLineStart := IntEditorAllCount-1;
    end;
    //ݒ
    IntLineEnd := IntLineStart + IntMoveNum;
    if IntLineEnd > IntEditorAllCount-1 then
    begin
      IntLineEnd := IntEditorAllCount-1;
    end;
    //\XV
    SetListData(Sender);
  end;
end;

procedure TFormCsvList.MenuCsvListEndClick(Sender: TObject);
begin
  //S
  if BoolLoadAll = TRUE then
  begin
    //bZ[WM
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_CONTROL, 0);
    PostMessage(ListView1.Handle, WM_KEYDOWN, VK_END, 0);
  end
  //s
  else
  begin
    //
    if IntLineStart = IntEditorAllCount-1 then
    begin
      Exit;
    end;

    //ݒ
    IntLineStart := IntEditorAllCount-1;
    //ݒ
    IntLineEnd   := IntEditorAllCount-1;
    //\XV
    SetListData(Sender);
  end;
end;

procedure TFormCsvList.SetListData(Sender: TObject);
var
  iRow1: Integer;
  iRow2: Integer;
  iRow3: Integer;
  iRow4: Integer;
  iPos1: Integer;
  iFind1: Integer;
  iMax1: Integer;
  nItem: TListItem;
  CsvList: TStringList;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolLoadAll = TRUE then
  begin
    //
    if IntEditorAllCount = 0 then
    begin
      Exit;
    end;

    //NA
    for iRow1 := 0 to HIGHI_LIGHT_MAX do
    begin
      ArrayListHighLightRow[iRow1] := -1;
      ArrayListHighLightCol[iRow1] := -1;
    end;

    //NA
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    ListView1.Items.EndUpdate;

    //XV
    ListView1.Items.BeginUpdate;
    //`
    iRow4 := 0;
    for iRow1 := 0 to IntEditorAllCount-1 do
    begin
      Application.ProcessMessages;
      if (iRow1 mod 100) = 0 then
      begin
        StatusBar1.Panels.Items[1].Text := Format('%.05d', [iRow1+1]);
        StatusBar1.Panels.Items[2].Text := Format('%.05d', [iRow1+1]);
        StatusBar1.Update;
      end;

      //m
      CsvList := TStringList.Create;

      //
      if StrListEditorAllLines.Strings[iRow1] <> '' then
      begin
        if MenuCsvAuto.Checked = TRUE then
        begin
          //WJ
          StringToCsvList(StrListEditorAllLines.Strings[iRow1], CsvList);
        end
        else if MenuCsvEx1.Checked = TRUE then
        begin
          //WJ
          StringToCsvListEx1(StrListEditorAllLines.Strings[iRow1], CsvList);
        end
        else
        begin
          //WJ
          StringToCsvList(StrListEditorAllLines.Strings[iRow1], CsvList);
        end;
        //ő區ڐ
        iMax1 := CsvList.Count;
        //1sݒ
        nItem := ListView1.Items.Add;
        nItem.Caption := Format('%.05d', [iRow1+1]);
        for iRow2 := 0 to CSVLIST_COL_MAX-1 do
        begin
          //ڂȂ
          if  iRow2 >= iMax1 then
          begin
            ListView1.Items.Item[iRow1].SubItems.Add('');
          end
          //ڂ
          else
          begin
            //ǉ
            ListView1.Items.Item[iRow1].SubItems.Add(CsvList[iRow2]);

            //
            iFind1 := -1;
            for iRow3 := 0 to StrListHighLight.Count-1 do
            begin
              //擾
              sStr2 := UpperCase(StrListHighLight.Strings[iRow3]);
              sStr3 := UpperCase(CsvList[iRow2]);
              //
              iPos1 := Pos(sStr2, sStr3);
              if iPos1 > 0 then
              begin
                iFind1 := iPos1;
                Break;
              end;
            end;
            //LΒǉ
            if iFind1 <> -1 then
            begin
              if iRow4 < HIGHI_LIGHT_MAX then
              begin
                ArrayListHighLightRow[iRow4] := IntLineStart + iRow1;
                ArrayListHighLightCol[iRow4] := iRow2;
              end;
              iRow4 := iRow4+1;
            end;
          end;
        end;
      end
      else
      begin
        //1sݒ
        nItem := ListView1.Items.Add;
        nItem.Caption := Format('%.05d', [iRow1+1]);
        //ڂȂ
        for iRow2 := 0 to CSVLIST_COL_MAX-1 do
        begin
          ListView1.Items.Item[iRow1].SubItems.Add('');
        end;
      end;

      //j
      CsvList.Free;
    end;
    //XV
    ListView1.Items.EndUpdate;

    //e
    if ListView1.Items.Count > 0 then
    begin
      ListView1.ItemIndex := 0;
      ListView1.Selected := ListView1.Items[0];
      ListView1.ItemFocused := ListView1.Items[0];
    end;

    //\
    StatusBar1.Panels.Items[1].Text := ListView1.Items[0].Caption;
    StatusBar1.Panels.Items[2].Text := ListView1.Items[ListView1.Items.Count-1].Caption;
    StatusBar1.Panels.Items[3].Text := Format('%.05d', [IntEditorAllCount]);


  end
  else
  begin
    //
    if IntEditorAllCount = 0 then
    begin
      Exit;
    end;

    //]
    StrListEditorLines.Clear;
    BoolStrLengthOver := FALSE;
    if IntLineStart = IntLineEnd then
    begin
        iRow1 := IntLineStart;
        if GetLine(iRow1, sStr1, Sender) > LINE_LENGTH_MAX then
        begin
          BoolStrLengthOver := TRUE;
        end;
        StrListEditorLines.Add(sStr1);
    end
    else
    begin
      for iRow1 := IntLineStart to IntLineEnd-1 do
      begin
        if GetLine(iRow1, sStr1, Sender) > LINE_LENGTH_MAX then
        begin
          BoolStrLengthOver := TRUE;
        end;
        StrListEditorLines.Add(sStr1);
      end;
    end;


    //NA
    for iRow1 := 0 to HIGHI_LIGHT_MAX do
    begin
      ArrayListHighLightRow[iRow1] := -1;
      ArrayListHighLightCol[iRow1] := -1;
    end;

    //NA
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    ListView1.Items.EndUpdate;

    //XV
    ListView1.Items.BeginUpdate;
    //`
    iRow4 := 0;
    for iRow1 := 0 to StrListEditorLines.Count-1 do
    begin
      //m
      CsvList := TStringList.Create;

      //
      if StrListEditorLines.Strings[iRow1] <> '' then
      begin
        if MenuCsvAuto.Checked = TRUE then
        begin
          //WJ
          StringToCsvList(StrListEditorLines.Strings[iRow1], CsvList);
        end
        else if MenuCsvEx1.Checked = TRUE then
        begin
          //WJ
          StringToCsvListEx1(StrListEditorLines.Strings[iRow1], CsvList);
        end
        else
        begin
          //WJ
          StringToCsvList(StrListEditorLines.Strings[iRow1], CsvList);
        end;
        //ő區ڐ
        iMax1 := CsvList.Count;
        //1sݒ
        nItem := ListView1.Items.Add;
        nItem.Caption := Format('%.05d', [IntLineStart+iRow1+1]);
        for iRow2 := 0 to CSVLIST_COL_MAX-1 do
        begin
          //ڂȂ
          if  iRow2 >= iMax1 then
          begin
            ListView1.Items.Item[iRow1].SubItems.Add('');
          end
          //ڂ
          else
          begin
            ListView1.Items.Item[iRow1].SubItems.Add(CsvList[iRow2]);

            //
            iFind1 := -1;
            for iRow3 := 0 to StrListHighLight.Count-1 do
            begin
              //擾
              sStr2 := UpperCase(StrListHighLight.Strings[iRow3]);
              sStr3 := UpperCase(CsvList[iRow2]);
              //
              iPos1 := Pos(sStr2, sStr3);
              if iPos1 > 0 then
              begin
                iFind1 := iPos1;
                Break;
              end;
            end;
            //LΒǉ
            if iFind1 <> -1 then
            begin
              if iRow4 < HIGHI_LIGHT_MAX then
              begin
                ArrayListHighLightRow[iRow4] := IntLineStart + iRow1;
                ArrayListHighLightCol[iRow4] := iRow2;
              end;
              iRow4 := iRow4+1;
            end;
          end;
        end;
      end
      else
      begin
        //1sݒ
        nItem := ListView1.Items.Add;
        nItem.Caption := Format('%.05d', [IntLineStart+iRow1+1]);
        //ڂȂ
        for iRow2 := 0 to CSVLIST_COL_MAX-1 do
        begin
          ListView1.Items.Item[iRow1].SubItems.Add('');
        end;
      end;

      //j
      CsvList.Free;
    end;
    //XV
    ListView1.Items.EndUpdate;

    //e
    if ListView1.Items.Count > 0 then
    begin
      ListView1.ItemIndex := 0;
      ListView1.Selected := ListView1.Items[0];
      ListView1.ItemFocused := ListView1.Items[0];
    end;

    //\
    StatusBar1.Panels.Items[1].Text := ListView1.Items[0].Caption;
    StatusBar1.Panels.Items[2].Text := ListView1.Items[ListView1.Items.Count-1].Caption;
    StatusBar1.Panels.Items[3].Text := Format('%.05d', [IntEditorAllCount]);

    //TCYI[o
    if BoolStrLengthOver = TRUE then
    begin
      showmessage('Ps̍s '  + Format('%d', [LINE_LENGTH_MAX]) + ' 𒴂s܂');
      Exit;
    end;

//    showmessage(Format('%d %d', [ArrayListHighLightRow[0], ArrayListHighLightCol[0]]));
//    showmessage(Format('%d %d', [ArrayListHighLightRow[1], ArrayListHighLightCol[1]]));
//    showmessage(Format('%d %d', [ArrayListHighLightRow[2], ArrayListHighLightCol[2]]));


  end;

  //XV
  ListView1.Refresh;

end;

procedure TFormCsvList.ComboBox3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormCsvList.ButtonSearchPrevClick(Sender: TObject);
begin
  //O
  MenuCsvListSearchPrevClick(Sender);
end;

procedure TFormCsvList.ButtonSearchNextClick(Sender: TObject);
begin
  //
  MenuCsvListSearchNextClick(Sender);
end;

procedure TFormCsvList.ListView1Click(Sender: TObject);
begin
  IntSearchCol := 0;
end;

procedure TFormCsvList.ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
  var DefaultDraw: Boolean);
var
  iRow1: Integer;
  iRow11: Integer;
  iRow12: Integer;
  iRow22: Integer;
  iFind1: Integer;
begin
  if MenuCsvListHiLightRow.Checked = TRUE then
  begin
    //擾
    iRow11 := IntLineStart;
    iRow12 := iRow11 + Item.Index;
    iFind1 := -1;
    //
    for iRow1:= 0 to High(ArrayListHighLightRow) do
    begin
      //擾
      iRow22 := ArrayListHighLightRow[iRow1];
      if iRow22 = -1 then
      begin
        break;
      end;
      //v
      if (iRow12 = iRow22) then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;


    //
    if iFind1 <> -1 then
    begin
      Sender.Canvas.Font.Color := ColorDialog2.Color;
    end
    //
    else
    begin
      Sender.Canvas.Font.Color := FontDialog1.Font.Color;
    end;
  end;

end;

procedure TFormCsvList.ListView1AdvancedCustomDrawSubItem(
  Sender: TCustomListView; Item: TListItem; SubItem: Integer;
  State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  iRow1: Integer;
  iRow11: Integer;
  iRow12: Integer;
  iRow13: Integer;
  iRow22: Integer;
  iRow23: Integer;
  iFind1: Integer;
begin
  if MenuCsvListHiLightCol.Checked = TRUE then
  begin
    //擾
    iRow11 := IntLineStart;
    iRow12 := iRow11 + Item.Index;
    iRow13 := SubItem;

    //
    iFind1 := -1;
    for iRow1:= 0 to High(ArrayListHighLightRow) do
    begin
      //擾
      iRow22 := ArrayListHighLightRow[iRow1];
      iRow23 := ArrayListHighLightCol[iRow1];
      if iRow22 = -1 then
      begin
        break;
      end;
      //v
      if (iRow12 = iRow22) and (iRow13 = iRow23+1) then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;

    //
    if iFind1 <> -1 then
    begin
      Sender.Canvas.Font.Color := clRed;
      Sender.Canvas.Font.Style := [fsBold];
    end
    //
    else
    begin
      Sender.Canvas.Font.Color := clBlue;
      Sender.Canvas.Font.Style := [];
    end;
  end;







{

    if (Item.Index = 1) and (SubItem = 2+1) then
    begin
      Sender.Canvas.Font.Color := FontDialog2.Font.Color;
      Sender.Canvas.Font.Style := [fsBold];
    end
    else if (Item.Index = 5) and (SubItem = 30+1) then
    begin
      Sender.Canvas.Font.Color := clRed;
      Sender.Canvas.Font.Style := [fsBold];
    end
    else
    begin
      Sender.Canvas.Font.Color := clBlue;
      Sender.Canvas.Font.Style := [];
    end;
     DefaultDraw := TRUE;
 if (Item.Index = 1) and (SubItem = 2+1) then
 begin
  Sender.Canvas.Font.Color := clRed;
 end
 else if (Item.Index = 5) and (SubItem = 30+1) then
 begin
  Sender.Canvas.Font.Color := clRed;
 end
 else
 begin
  Sender.Canvas.Font.Color := clBlue;
 end;
}


end;

procedure TFormCsvList.MenuCsvListSearchNextClick(Sender: TObject);
var
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
  iRow1: Integer;
  iRow3: Integer;
  iCol1: Integer;
  iStartCol1: Integer;
  iStartRow1: Integer;
  iFind1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  StrList1: TStringList;
begin
  //XV
  if ComboBox3.Text <> '' then
  begin
    //ݒ
    StrSearchValue := ComboBox3.Text;
    //d폜
    for iRow1 := 0 to ComboBox3.Items.Count-1 do
    begin
      if ComboBox3.Items[iRow1] = ComboBox3.Text then
      begin
        //폜
        ComboBox3.Items.Delete(iRow1);
        Break;
      end;
    end;
    //擪ɑ}
    ComboBox3.Items.Insert(0, StrSearchValue);
    if ComboBox3.Items.Count > SERACH_MAX then
    begin
      ComboBox3.Items.Delete(ComboBox3.Items.Count-1);
    end;
    //ݒ
    ComboBox3.Text := StrSearchValue;
  end
  else
  begin
    showmessage('ꂪݒ肳Ă܂');
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  //
  iFind1 := -1;
  iStartRow1 := ListView1.ItemIndex;
  iStartCol1 := IntSearchCol;
  for iRow1 := iStartRow1 to ListView1.Items.Count-1 do
  begin
    for iCol1 := iStartCol1+1 to CSVLIST_COL_MAX-1 do
    begin
      sStr2 := ListView1.Items[iRow1].SubItems[iCol1];
      if Pos(AnsiUpperCase(StrSearchValue), AnsiUpperCase(sStr2)) > 0  then
      begin
        iFind1 := iRow1;
        StrList1.Add(Format('%.02d', [iCol1+1]));
        IntSearchRow := iRow1;
        IntSearchCol := iCol1;
      end;
    end;
    if iFind1 = -1 then
    begin
      iStartCol1 := -1;
    end
    else
    begin
      Break
    end;
  end;

  if iFind1 = -1 then
  begin
    StatusBar1.Panels.Items[4].Text := INIT_SERACH;
    sStr1 := '܂܂ł'
             + #13#10 + StrSearchValue;
    ShowMessage(sStr1);
  end
  else
  begin
    for iRow3 :=0 to StrList1.Count-1 do
    begin
      if irow3 = (StrList1.Count-1) then
      begin
        sStr3 := sStr3 + StrList1.Strings[iRow3];
      end
      else
      begin
        sStr3 := sStr3 + StrList1.Strings[iRow3] + '/';
      end;
    end;
    //\
    StatusBar1.Panels.Items[4].Text := 's:' + ListView1.Items[IntSearchRow].Caption + ' :' + sSTr3;;

    //ڂɃtH[JX킳Ȃƃ_BDelph7 ͕KvBXE2͂ȂĂvB
    //擪ȊO̓J[\ړőΉ
    ListView1.Items.BeginUpdate;
    ListView1.ItemIndex := IntSearchRow;
    ListView1.Selected := ListView1.Items[IntSearchRow];
    ListView1.ItemFocused := ListView1.Items[IntSearchRow];
    //1s̍擾ăXN[
    iIndex1 := ListView1.TopItem.Index;
    iIndex2 := ListView1.ItemIndex;
    Rect1 := ListView1.Items[0].DisplayRect(drBounds);
    ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
    ListView1.Items.EndUpdate;
//    ListView1.SetFocus;
  end;
  //j
  StrList1.Free;
end;

procedure TFormCsvList.MenuCsvListSearchPrevClick(Sender: TObject);
var
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
  iRow1: Integer;
  iRow3: Integer;
  iCol1: Integer;
  iStartCol1: Integer;
  iStartRow1: Integer;
  iFind1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  StrList1: TStringList;
begin
  //XV
  if ComboBox3.Text <> '' then
  begin
    //ݒ
    StrSearchValue := ComboBox3.Text;
    //d폜
    for iRow1 := 0 to ComboBox3.Items.Count-1 do
    begin
      if ComboBox3.Items[iRow1] = ComboBox3.Text then
      begin
        //폜
        ComboBox3.Items.Delete(iRow1);
        Break;
      end;
    end;
    //擪ɑ}
    ComboBox3.Items.Insert(0, StrSearchValue);
    if ComboBox3.Items.Count > SERACH_MAX then
    begin
      ComboBox3.Items.Delete(ComboBox3.Items.Count-1);
    end;
    //ݒ
    ComboBox3.Text := StrSearchValue;
  end
  else
  begin
    showmessage('ꂪݒ肳Ă܂');
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  //
  iFind1 := -1;
  iStartRow1 := ListView1.ItemIndex;
  iStartCol1 := IntSearchCol;
  for iRow1 := iStartRow1 downto 0 do
  begin
    for iCol1 := iStartCol1+1 to CSVLIST_COL_MAX-1 do
    begin
      sStr2 := ListView1.Items[iRow1].SubItems[iCol1];
      if Pos(AnsiUpperCase(StrSearchValue), AnsiUpperCase(sStr2)) > 0  then
      begin
        iFind1 := iRow1;
        StrList1.Add(Format('%.02d', [iCol1+1]));
        IntSearchRow := iRow1;
        IntSearchCol := iCol1;
      end;
    end;
    if iFind1 = -1 then
    begin
      iStartCol1 := -1;
    end
    else
    begin
      Break
    end;
  end;

  if iFind1 = -1 then
  begin
    StatusBar1.Panels.Items[4].Text := INIT_SERACH;
    sStr1 := '܂܂ł'
             + #13#10 + StrSearchValue;
    ShowMessage(sStr1);
  end
  else
  begin
    for iRow3 :=0 to StrList1.Count-1 do
    begin
      if irow3 = (StrList1.Count-1) then
      begin
        sStr3 := sStr3 + StrList1.Strings[iRow3];
      end
      else
      begin
        sStr3 := sStr3 + StrList1.Strings[iRow3] + '/';
      end;
    end;
    //\
    StatusBar1.Panels.Items[4].Text := 's:' + ListView1.Items[IntSearchRow].Caption + ' :' + sSTr3;;

    //ڂɃtH[JX킳Ȃƃ_BDelph7 ͕KvBXE2͂ȂĂvB
    //擪ȊO̓J[\ړőΉ
    ListView1.Items.BeginUpdate;
    ListView1.ItemIndex := IntSearchRow;
    ListView1.Selected := ListView1.Items[IntSearchRow];
    ListView1.ItemFocused := ListView1.Items[IntSearchRow];
    //1s̍擾ăXN[
    iIndex1 := ListView1.TopItem.Index;
    iIndex2 := ListView1.ItemIndex;
    Rect1 := ListView1.Items[0].DisplayRect(drBounds);
    ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
    ListView1.Items.EndUpdate;
//    ListView1.SetFocus;
  end;
  //j
  StrList1.Free;
end;

procedure TFormCsvList.MenuCsvListFontColorClick(Sender: TObject);
begin
  if FontDialog1.Execute = TRUE then
  begin
    //f
    ListView1.Font.Name  := FontDialog1.Font.Name;
    ListView1.Font.Size  := FontDialog1.Font.Size;
    ListView1.Font.Color := FontDialog1.Font.Color;
    ListView1.Columns[0].Width := CSVLIST_CAPTION_WIDTH * FontDialog1.Font.Size div CSVLIST_FONT_SIZE;
  end;

end;

procedure TFormCsvList.MenuCsvListFontColorHilightColClick(Sender: TObject);
begin
  showmessage('ʏ\͐FA\͐ԐF()ɌŒł');
end;

procedure TFormCsvList.MenuCsvListFontColorHilightRowClick(Sender: TObject);
begin
  if ColorDialog2.Execute = TRUE then
  begin
    //XV
    ListView1.Refresh;
  end;
end;

procedure TFormCsvList.MenuCsvListHiLightNoneClick(Sender: TObject);
begin
  if MenuCsvListHiLightNone.Checked = FALSE then
  begin
    MenuCsvListHiLightNone.Checked := TRUE;
    MenuCsvListHiLightRow.Checked  := FALSE;
    MenuCsvListHiLightCol.Checked  := FALSE;
  end;
  //XV
  ListView1.Refresh;

end;

procedure TFormCsvList.MenuCsvListHiLightRowClick(Sender: TObject);
begin
  if MenuCsvListHiLightRow.Checked = FALSE then
  begin
    MenuCsvListHiLightNone.Checked := FALSE;
    MenuCsvListHiLightRow.Checked  := TRUE;
    MenuCsvListHiLightCol.Checked  := FALSE;
  end;
  //XV
  ListView1.Refresh;
end;

procedure TFormCsvList.MenuCsvListHiLightColClick(Sender: TObject);
begin
  if MenuCsvListHiLightCol.Checked = FALSE then
  begin
    MenuCsvListHiLightNone.Checked := FALSE;
    MenuCsvListHiLightRow.Checked  := FALSE;
    MenuCsvListHiLightCol.Checked  := TRUE;
  end;
  //XV
  ListView1.Refresh;

end;

procedure TFormCsvList.MenuCsvListHiligtFileClick(Sender: TObject);
begin
  OpenDialog1.Filter     := 'Text(*.txt)|*.txt|All(*.*)|*.*';
  OpenDialog1.FileName   := ExtractFileName(StrHighLightFileName);
  OpenDialog1.InitialDir := ExtractFilePath(StrHighLightFileName);
  if OpenDialog1.Execute = TRUE then
  begin
    StrHighLightFileName := OpenDialog1.FileName;
    if FileExists(StrHighLightFileName) = TRUE then
    begin
      StrListHighLight.LoadFromFile(StrHighLightFileName);
    end;
    //XV
    ListView1.Refresh;
  end
end;

procedure TFormCsvList.MenuCsvAutoClick(Sender: TObject);
begin
  if MenuCsvAuto.Checked = TRUE then
  begin
    MenuCsvAuto.Checked := FALSE;
  end
  else
  begin
    MenuCsvAuto.Checked := TRUE;
  end;
  //f[^\
  SetListData(Sender);
end;

procedure TFormCsvList.MenuCsvEx1Click(Sender: TObject);
begin
{
  if MenuCsvEx1.Checked = TRUE then
  begin
    MenuCsvEx1.Checked := FALSE;
  end
  else
  begin
    MenuCsvEx1.Checked := TRUE;
  end;
}
end;

procedure TFormCsvList.MenuCsvListBackColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute = TRUE then
  begin
    //f
    ListView1.Color := ColorDialog1.Color;
  end;
end;

procedure TFormCsvList.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormCsvList.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;



procedure TFormCsvList.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := StrDllFilePath + KEYMAP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    StrListKeyMap.LoadFromFile(sStr1);
  end
  //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
  else
  begin
    StrListKeyMap.SaveToFile(sStr1);
  end;

  //ݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1001', MenuCsvListLoadAll, Sender);
    SetShortCutNew('1002', MenuCsvListFitColumnWidth, Sender);
    SetShortCutNew('1011', MenuCsvListClose, Sender);

    SetShortCutNew('1101', MenuCsvListSearchNext, Sender);
    SetShortCutNew('1102', MenuCsvListSearchPrev, Sender);

    SetShortCutNew('1201', MenuCsvListJump, Sender);
    SetShortCutNew('1202', MenuCsvListTop, Sender);
    SetShortCutNew('1203', MenuCsvListPrev, Sender);
    SetShortCutNew('1204', MenuCsvListNext, Sender);
    SetShortCutNew('1205', MenuCsvListEnd, Sender);

    SetShortCutNew('1301', MenuCsvListFontColor, Sender);
    SetShortCutNew('1302', MenuCsvListBackColor, Sender);

    SetShortCutNew('1401', MenuCsvListKeyBoard, Sender);

    SetShortCutNew('1501', MenuCsvListShowHelp, Sender);
  end;
end;

function  TFormCsvList.GetLine(Index: Integer; var LineString: String; Sender: TObject): Integer;
var
  LLen: Integer;
  LBuf: array of Char;
  LInfo: TGetLineInfo;
begin
//                      0; \sŎ擾
// FLAG_LOGICAL       = 1; _sŎ擾
// FLAG_WITH_CRLF     = 2; 擾镶̖ɉs܂߂)
// FLAG_GET_CRLF_BYTE = 4; byteCrLf ̕ɏ܂߂Ď擾
//
// byteCrLf́Aflags  FLAG_GET_CRLF_BYTE ܂߂ꍇɁAbyteCrLf ̒Ɉȉ̏Ԃ
//                0; sR[h CRLF
// FLAG_CR_ONLY = 1; sR[h CR
// FLAG_LF_ONLY = 2; sR[h LF

  //PڂŃTCY擾
  LInfo.cch      := 0;            // 0 ݒ肷ƁAobt@TCYԂ
  LInfo.flags    := FLAG_LOGICAL; // _s
  LInfo.yLine    := Index;        // 0 x[X̍sԍn
  LInfo.byteCrLf := 0;            // CrLf ͊܂߂Ȃ
  LLen := Editor_GetLine(Application.Handle, @LInfo, nil);

  //m
  SetLength(LBuf, LLen+1);
  //Ô߃NA
  FillChar(LBuf[0], (LLen+1) * SizeOf(Char), #0);

  //Qڂŕ擾
  LInfo.cch := LLen;              // TCYw
  Editor_GetLine(Application.Handle, @LInfo, PChar(LBuf));

  //
  //PChar ̃LXg͐
  LineString := PChar(Lbuf);
//String() ̃LXg̓_
//LineString := String(Lbuf);

  //
  Result := LLen;
end;


procedure TFormCsvList.MenuMoveStartPositionClick(Sender: TObject);
var
  iPos1: Integer;
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
begin
    //ݒ
    iPos1 := IntStartNum;

    //S
    if BoolLoadAll = TRUE then
    begin
      //ڂɃtH[JX킳Ȃƃ_BDelph7 ͕KvBXE2͂ȂĂvB
      //擪ȊO̓J[\ړőΉ
      ListView1.Items.BeginUpdate;
      ListView1.ItemIndex := iPos1;
      ListView1.Selected := ListView1.Items[iPos1];
      ListView1.ItemFocused := ListView1.Items[iPos1];
      //1s̍擾ăXN[
      iIndex1 := ListView1.TopItem.Index;
      iIndex2 := ListView1.ItemIndex;
      Rect1 := ListView1.Items[0].DisplayRect(drBounds);
      ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
      ListView1.Items.EndUpdate;
      //\
      StatusBar1.Panels.Items[1].Text := ListView1.Items[0].Caption;
      StatusBar1.Panels.Items[2].Text := ListView1.Items[ListView1.Items.Count-1].Caption;
      StatusBar1.Update;
    end
    //s
    else
    begin
      //ݒ
      IntLineStart := iPos1;
      if IntLineStart < 0 then
      begin
        IntLineStart := 0;
      end;
      //ݒ
      IntLineEnd := IntLineStart + IntMoveNum;
      if IntLineEnd > IntEditorAllCount-1 then
      begin
        IntLineEnd := IntEditorAllCount-1;
      end;
      //\XV
      SetListData(Sender);
    end;
end;


procedure TFormCsvList.MenuAddHeaderClick(Sender: TObject);
var
  iCol1: Integer;
  sStr1: String;
begin
  if (ListView1.Items.Count > 0) and (ListView1.ItemIndex >= 0) then
  begin
    //XV
    ListView1.Items.BeginUpdate;
    //ݒ
    for iCol1 := 0 to CSVLIST_COL_MAX-1 do
    begin
      //ǉ
      sStr1 := ListView1.Items[ListView1.ItemIndex].SubItems[iCol1+0];
      ListView1.Columns[iCol1+1].Caption := Format('%.02d', [iCol1+1]) + ' ' + sStr1;
      //\
      Application.ProcessMessages;
      if (iCol1 mod 10) = 0 then
      begin
        StatusBar1.Panels.Items[1].Text := Format('%.02d', [iCol1+1]);
        StatusBar1.Panels.Items[2].Text := Format('%.02d', [CSVLIST_COL_MAX]);
        StatusBar1.Update;
      end;
    end;
    //XV
    ListView1.Items.EndUpdate;
    //tH[JXݒ
    ListView1.SetFocus;
    //\
    StatusBar1.Panels.Items[1].Text := Format('%.02d', [CSVLIST_COL_MAX]);
    StatusBar1.Panels.Items[2].Text := Format('%.02d', [CSVLIST_COL_MAX]);
    StatusBar1.Update;
  end;
end;


end.

